/**********************************************************************************/
/*                                                                                */
/*                         "libasm.s"                                             */
/*               Cassiopeia A-51 CRpC ver 0.1                              */
/*                 eXgpX^[gAbvCu                               */
/*  (ӁF̃t@C̓eXgpłAdl͗\ȂɕύX邱Ƃ܂)  */
/*                                                                                */
/*                                                                                */
/**********************************************************************************/


EOF: equ 255
ERROR: equ -1
NULL: equ 0
SPACE: equ 32
CR: equ 13
LF: equ 10
PLUS: equ 43
MINUS: equ 45
ESC: equ 27
NaN: equ 0x80000000
WM_KEYUP: equ 0x0101
WM_CHAR: equ 0x0102

/* vOJnʒu */
/* R}hC(Ch)i[ */
__StartLib:
  sts.l pr,@-r15
  .align4
  mov.l @(1,pc),r0
  mov.l r6,@r0
  bra $+8
  nop
  .data.l __command_line

/* R\[EBhET */
  .align4
  mov.l @(5,pc),r4
  mov #0,r5
  mov.l @(5,pc),r0
  mov.l @r0,r0
  jsr @r0
  nop
  mov.l @(4,pc),r3
  mov.l r0,@r3
  cmp.eq #0,r0
  bf  __Start1
  bra __Start4
  nop
 .data.l __xconsole
 .data.l __tFindWindowW
 .data.l __hConsole

__xconsole:
  .data.w 'C'
  .data.w 'o'
  .data.w 'n'
  .data.w 's'
  .data.w 'o'
  .data.w 'l'
  .data.w 'e'
  .data.w 0

/* L[̓vZXo^ */
__Start1:
  .align4
 mov r0,r4
 mov #-4,r5
 mov.l @(9,pc),r0
 mov.l @r0,r0
 jsr @r0
 nop
 mov.l @(8,pc),r4
 mov.l r0,@r4
 mov.l @(5,pc),r4
 mov.l @r4,r4
 mov #-4,r5
 nop
 mov.l @(6,pc),r6
 nop
 mov.l @(6,pc),r0
 mov.l @r0,r0
 jsr @r0
 nop
 bra __Start2
 nop
 .data.l __hConsole
 .data.l __tGetWindowLongW
 .data.l __oldProc
 .data.l __KeyinProc
 .data.l __tSetWindowLongW

/* mainĂяo */	
__Start2:
 mov.l @(2,pc),r0
 jsr @r0
 nop
 bra __Start3
 nop
 nop
 .data.l __entry_main

/* L[̓vZX폜 */
__Start3:
 mov.l @(5,pc),r4
 mov.l @r4,r4
 mov #-4,r5
 nop
 mov.l @(4,pc),r6
 mov.l @r6,r6
 mov.l @(4,pc),r0
 mov.l @r0,r0
 jsr @r0
 nop
 bra __Start4
 nop
 .data.l __hConsole
 .data.l __oldProc
 .data.l __tSetWindowLongW

/* OSɖ߂ */
__Start4:
 lds.l @r15+,pr
 rts
 nop


/* L[̓vZXŎsR[h */
/* r4=hWnd, r5=msg, r6=wParam, r7=lParam */
__KeyinProc:
 .align4
 sts.l pr,@-r15
 add #-20,r15
 mov.l @(4,pc),r0
 cmp.eq r0,r5
 bt __KeyinProc1
 nop
 mov.l @(3,pc),r0
 cmp.eq r0,r5
 bt __KeyinProc2
 nop
 bra __KeyinProc3
 nop
 .data.l WM_KEYUP
 .data.l WM_CHAR

__KeyinProc1:
 .align4
 mov.l @(2,pc),r3
 mov #0,r0
 mov.w r0,@r3
 mov #0,r0
 bra __KeyinProc4
 nop
 .data.l __keyCode

__KeyinProc2:
 .align4
 mov.l @(2,pc),r3
 mov.w r6,@r3
 mov #0,r0
 bra __KeyinProc4
 nop
 nop
 .data.l __keyCode

__KeyinProc3:
 .align4
 mov.l r7,@(4,r15)
 mov r6,r7
 mov r5,r6
 mov r4,r5
 mov.l @(3,pc),r3
 mov.l @r3,r4
 mov.l @(3,pc),r0
 mov.l @r0,r0
 jsr @r0
 nop
 bra __KeyinProc4
 nop
 .data.l __oldProc
 .data.l __tCallWindowProcW
__KeyinProc4:
 add #20,r15
 lds.l @r15+,pr
 rts
 nop


/* R0(32 rbg)R1(32 rbg)R0(32 rbg) t */
  .align4
__idiv:
 mov r0,r12
 mov r1,r0
 mov r12,r1 
 tst r0,r0
 bf $+6
 bra __zero_div
 nop
 mov r1,r12
 mov r12,r11
 rotcl r11
 subc r1,r1
 xor r11,r11
 subc r11,r12
 div0s r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 addc r11,r12
 mov r12,r0
 rts
 nop


/* R0(32 rbg)R1(32 rbg)R0(32 rbg) Ȃ */
  .align4
__udiv:
 mov r0,r12
 mov r1,r0
 mov r12,r1 
 tst r0,r0
 bf $+6
 bra __zero_div
 nop
 mov r1,r12
 mov #0,r1
 div0u
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 div1 r0,r1
 rotcl r12
 mov r12,r0
 rts
 nop

/* [ZN̏ */
  .align4
__zero_div:
 mov.l @(1,pc),r0
 rts
 nop
 nop
 .data.l NaN


/* R0(32 rbg)R1(32 rbg)̗]聨R0(32 rbg) Ȃ */
  .align4
__imod:
  sts.l pr,@-r15
  mov r0,r2
  mov.l @(2,pc),r12
  mov r1,r3
  jsr @r12
  nop
  bra $+8
  nop
  .data.l __udiv
  dmulu.l r0,r3
  sts macl,r0
  sub r0,r2
  mov r2,r0
  lds.l @r15+,pr
  rts
  nop


/* vÖꎞ~(Pʂ̓~b) */
; int sleep( int t )
  .align4
sleep:
 .data.l __entry_sleep
__entry_sleep:
  nop
  mov.l @r15,r0
  sts.l pr,@-r15
  mov r0,r4
  mov.l @(3,pc),r0
  mov.l @r0,r0
  jsr @r0
  nop
  lds.l @r15+,pr
  rts
  nop
  nop
  .data.l __tSleep


/* R\[1o͂ */
; int putch( char c )
  .align4
putch:
 .data.l __entry_putch
__entry_putch:
  mov.l @r15,r0
  extu.b r0,r0
  mov.l @(6,pc),r4
  mov.l @r4,r4
  mov.w @(9,pc),r5
  sts.l pr,@-r15
  mov.l @(5,pc),r6
  mov r0,r7
  mov.l @(5,pc),r0
  mov.l @r0,r0
  jsr @r0
  nop
  lds.l @r15+,pr
  rts
  nop
  .data.w 0x111
  .data.l __hConsole
  .data.l 40002
  .data.l __tSendMessageW


/* Chɕϊ */
; TCHAR* _WIDE( char* str )
  .align4
_WIDE:
 .data.l __entry__WIDE
__entry__WIDE:
  nop
  mov.l @r15,r2      /* str */
  mov.l @(12,pc),r1  /* __wbuf */ 
  nop
  mov.l @(10,pc),r0  /* 512 */
  sts.l pr,@-r15
  add #-24,r15
  mov #0,r4
  mov #0,r5
  mov r2,r6
  mov #-1,r7
  mov.l r1,@(4,r15)
  mov.l r0,@(5,r15)
  nop
  mov.l @(4,pc),r0   /* __tMultiByteToWideChar */
  mov.l @r0,r0
  jsr @r0
  nop
  add #24,r15
  lds.l @r15+,pr
  mov.l @(3,pc),r0   /* __wbuf */
  rts
  nop
  nop
  .data.l __tMultiByteToWideChar
  .data.l 512
  .data.l __wbuf


/* ǂݍ݃[hŃt@CJ */
; FILE _ropen( TCHAR* t )
  .align4
_ropen:
 .data.l __entry__ropen
__entry__ropen:
 mov.l @r15,r0
 sts.l pr,@-r15
 add #-28,r15
 mov r0,r4
 mov.l @(8,pc),r5
 mov #0,r6
 mov #0,r7
 mov #3,r2
 mov.l r2,@(4,r15)
 mov #64,r1
 shll r1
 mov.l r1,@(5,r15)
 mov #0,r3
 mov.l r3,@(6,r15)
 mov.l @(4,pc),r0
 mov.l @r0,r0
 jsr @r0
 nop
 add #28,r15
 lds.l @r15+,pr
 rts
 nop
 .data.l 0x80000000
 .data.l __tCreateFileW


/* ݃[hŃt@CJ */
; FILE _wopen( TCHAR* t )
  .align4
_wopen:
 .data.l __entry__wopen
__entry__wopen:
 mov.l @r15,r0
 sts.l pr,@-r15
 add #-28,r15
 mov r0,r4
 mov.l @(8,pc),r5
 mov #0,r6
 mov #0,r7
 mov #2,r2
 mov.l r2,@(4,r15)
 mov #64,r1
 shll r1
 mov.l r1,@(5,r15)
 mov #0,r3
 mov.l r3,@(6,r15)
 mov.l @(4,pc),r0
 mov.l @r0,r0
 jsr @r0
 nop
 add #28,r15
 lds.l @r15+,pr
 rts
 nop
 .data.l 0x40000000
 .data.l __tCreateFileW


/* t@Cǂݍ */
; int _read( FILE fp, char* buf, int size )
  .align4
_read:
 .data.l __entry__read
__entry__read:
 mov.l @r15,r2
 mov.l @(2,r15),r1
 mov.l @(4,r15),r0
 sts.l pr,@-r15
 add #-20,r15
 mov r2,r4
 mov r1,r5
 mov r0,r6
 mov.l @(6,pc),r7
 mov #0,r0
 mov.l r0,@(4,r15)
 nop
 mov.l @(5,pc),r0
 mov.l @r0,r0
 jsr @r0
 nop
 mov.l @(2,pc),r0
 mov.l @r0,r0
 add #20,r15
 lds.l @r15+,pr
 rts
 nop
 .data.l __dSize
 .data.l __tReadFile


/* t@Cɏ */
; int _write( FILE fp, char* buf, int size )
  .align4
_write:
 .data.l __entry__write
__entry__write:
 mov.l @r15,r2
 mov.l @(2,r15),r1
 mov.l @(4,r15),r0
 sts.l pr,@-r15
 add #-20,r15
 mov r2,r4
 mov r1,r5
 mov r0,r6
 mov.l @(6,pc),r7
 mov #0,r0
 mov.l r0,@(4,r15)
 nop
 mov.l @(5,pc),r0
 mov.l @r0,r0
 jsr @r0
 nop
 mov.l @(2,pc),r0
 mov.l @r0,r0
 add #20,r15
 lds.l @r15+,pr
 rts
 nop
 .data.l __dSize
 .data.l __tWriteFile


/* t@C */
; int _close( FILE fp )
  .align4
_close:
 .data.l __entry__close
__entry__close:
 mov.l @r15,r4
 sts.l pr,@-r15
 mov.l @(3,pc),r0
 mov.l @r0,r0
 jsr @r0
 nop
 lds.l @r15+,pr
 rts
 nop
 nop
 .data.l __tCloseHandle
