/*****************************************************************************/
/*                                                                           */
/*                         "libasm.s"                                        */
/*               Cassiopeia E-55 CRpC ver 0.2                          */
/*                 eXgpX^[gAbvCu                            */
/*  (ӁF̃t@C̓eXgpłAdl͗\ȂɕύX邱Ƃ܂)  */
/*                                                                           */
/*                                                                           */
/*****************************************************************************/


EOF: equ 255
ERROR: equ -1
NULL: equ 0
SPACE: equ 32
CR: equ 13
LF: equ 10
PLUS: equ 43
MINUS: equ 45
ESC: equ 27
NaN: equ 0x80000000
WM_KEYUP: equ 0x0101
WM_CHAR: equ 0x0102

/* vOJnʒu */
/* R}hC(Ch)i[ */
__Start:
 addiu sp,sp,-0x20
 sw ra,0x14(sp)
 sw a0,0x20(sp)
 sw a1,0x24(sp)
 sw a2,0x28(sp)
 sw a3,0x2c(sp)
 li t0,__command_line
 sw a2,(t0)

/* R\[EBhET */
 li a0,__xconsole
 move a1,zero
 li t0,__tFindWindowW
 lw t0,(t0)
 jalr t0
 nop
 li t0,__hConsole
 sw v0,(t0)
 beq v0,zero,__Start2
 nop
 
/* L[̓vZXo^ */
 li t0,__hConsole
 lw a0,(t0)
 li a1,-4
 li t0,__tGetWindowLongW
 lw t0,(t0)
 jalr t0
 nop
 li t0,__oldProc
 sw v0,(t0)
 li t0,__hConsole
 lw a0,(t0)
 li a1,-4
 li a2,__KeyinProc
 li t0,__tSetWindowLongW
 lw t0,(t0)
 jalr t0
 nop

/* mainĂяo */	
 li t0,main
 lw t0,(t0)
 jalr t0
 nop
 
/* L[̓vZX폜 */
 li t0,__hConsole
 lw a0,(t0)
 li a1,-4
 li t0,__oldProc
 lw a2,(t0)
 li t0,__tSetWindowLongW
 lw t0,(t0)
 jalr t0
 nop

/* OSɖ߂ */
__Start2:
 move v0,zero
 lw ra,0x14(sp)
 addiu sp,sp,0x20
 jr ra
 nop
__xconsole:
  .data.w 'C'
  .data.w 'o'
  .data.w 'n'
  .data.w 's'
  .data.w 'o'
  .data.w 'l'
  .data.w 'e'
  .data.w 0
 .align4


/* L[̓vZXŎsR[h */
/* a0=hWnd, a1=msg, a2=wParam, a3=lParam */
__KeyinProc:
 addiu sp,sp,-0x28
 sw ra,0x1c(sp)
 sw a0,0x28(sp)
 sw a1,0x2c(sp)
 sw a2,0x30(sp)
 sw a3,0x34(sp)

/* if( msg == WM_CHAR ) __keyCode = wparam */
__KeyinProc1:
 li t0,WM_CHAR
 li t1,0xffff
 and a1,a1,t1
 bne a1,t0,__KeyinProc2
 nop
 li t0,__keyCode
 sh a2,(t0)
 move v0,zero
 bra __KeyinProc3
 nop

/* else  CallWindowProc( __oldProc, hWnd, msg, wParam, lParam ) */
__KeyinProc2:
 li t0,__oldProc
 lw a0,(t0)
 lw a1,0x28(sp)
 lw a2,0x2c(sp)
 lw a3,0x30(sp)
 lw t8,0x34(sp)
 sw t8,0x10(sp)
 li t0,__tCallWindowProcW
 lw t0,(t0)
 jalr t0
 nop

/* I */
__KeyinProc3:
 lw ra,0x1c(sp)
 addiu sp,sp,0x28
 jr ra
 nop


/* vÖꎞ~(Pʂ̓~b) */
; int sleep( int t )
sleep:
 .data.l __entry_sleep
__entry_sleep:
 lw a0,(sp)
 addiu sp,sp,-24
 sw ra,20(sp)
 li t0,__tSleep
 lw t0,(t0)
 jalr t0
 nop
 lw ra,20(sp)
 addiu sp,sp,24
 jr ra
 nop


/* R\[1o͂ */
; int putch( char c )
putch:
 .data.l __entry_putch
__entry_putch:
 lw a3,(sp)
 andi a3,a3,0xff 
 addiu sp,sp,-32
 sw ra,32(sp)
 li a0,__hConsole
 lw a0,(a0)
 li a1,0x111
 li a2,40002
 li t0,__tSendMessageW
 lw t0,(t0)
 jalr t0
 nop
 lw ra,32(sp)
 addiu sp,sp,32
 jr ra
 nop


/* Chɕϊ */
; TCHAR* _WIDE( char* str )
_WIDE:
 .data.l __entry__WIDE
__entry__WIDE:
 lw a2,(sp)
 addiu sp,sp,-64
 sw ra,(sp)
 li t0,512
 li t1,__wbuf
 move a0,zero
 move a1,zero
 li a3,-1
 sw t1,16(sp)
 sw t0,20(sp)
 li t0,__tMultiByteToWideChar
 lw t0,(t0)
 jalr t0
 nop
 li v0,__wbuf
 lw ra,(sp)
 addiu sp,sp,64
 jr ra
 nop


/* ǂݍ݃[hŃt@CJ */
; FILE _ropen( TCHAR* t )
_ropen:
 .data.l __entry__ropen
__entry__ropen:
 lw a0,(sp)
 addiu sp,sp,-32
 sw ra,(sp)
 li a1,0x80000000
 move a2,zero
 move a3,zero
 li t0,3
 sw t0,16(sp)
 li t0,128
 sw t0,20(sp)
 sw zero,24(sp)
 li t0,__tCreateFileW
 lw t0,(t0)
 jalr t0
 nop
 lw ra,(sp)
 addiu sp,sp,32
 jr ra
 nop


/* ݃[hŃt@CJ */
; FILE _wopen( TCHAR* t )
_wopen:
 .data.l __entry__wopen
__entry__wopen:
 lw a0,(sp)
 addiu sp,sp,-32
 sw ra,(sp)
 li a1,0x40000000
 move a2,zero
 move a3,zero
 li t0,2
 sw t0,16(sp)
 li t0,128
 sw t0,20(sp)
 sw zero,24(sp)
 li t0,__tCreateFileW
 lw t0,(t0)
 jalr t0
 nop
 lw ra,(sp)
 addiu sp,sp,32
 jr ra
 nop


/* t@Cǂݍ */
; int _read( FILE fp, char* buf, int size )
_read:
 .data.l __entry__read
__entry__read:
 lw a0,(sp)
 lw a1,8(sp)
 lw a2,16(sp)
 addiu sp,sp,-32
 sw ra,(sp)
 li a3,__dSize
 sw zero,16(sp)
 li t0,__tReadFile
 lw t0,(t0)
 jalr t0
 nop
 li t0,__dSize
 lw v0,(t0)
 lw ra,(sp)
 addiu sp,sp,32
 jr ra
 nop


/* t@Cɏ */
; int _write( FILE fp, char* buf, int size )
_write:
 .data.l __entry__write
__entry__write:
 lw a0,(sp)
 lw a1,8(sp)
 lw a2,16(sp)
 addiu sp,sp,-32
 sw ra,(sp)
 li a3,__dSize
 sw zero,16(sp)
 li t0,__tWriteFile
 lw t0,(t0)
 jalr t0
 nop
 li t0,__dSize
 lw v0,(t0)
 lw ra,(sp)
 addiu sp,sp,32
 jr ra
 nop


/* t@C */
; int _close( FILE fp )
_close:
 .data.l __entry__close
__entry__close:
 lw a0,(sp)
 addiu sp,sp,-32
 sw ra,(sp)
 li t0,__tCloseHandle
 lw t0,(t0)
 jalr t0
 nop
 lw ra,(sp)
 addiu sp,sp,32
 jr ra
 nop


